' Fig. 20.22: Generator.aspx.vb
' The code-behind file for a page that
' generates words when given a phone number.

Imports System.Web.UI.WebControls

Public Class Generator
   Inherits System.Web.UI.Page

   Protected WithEvents phoneInputValidator As _
      RequiredFieldValidator

   Protected WithEvents phoneNumberValidator As _
      RegularExpressionValidator

   Protected WithEvents promptLabel As Label
   Protected WithEvents outputTextBox As TextBox
   Protected WithEvents submitButton As Button
   Protected WithEvents phoneTextBox As TextBox

#Region " Web Form Designer Generated Code "

   'This call is required by the Web Form Designer.
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

   End Sub

   Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
      'CODEGEN: This method call is required by the Web Form Designer
      'Do not modify it using the code editor.
      InitializeComponent()
   End Sub

#End Region

   Private Sub Page_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

      ' if not first time page loads
      If IsPostBack Then
         Dim number As String

         outputTextBox.Text() = ""

         ' retrieve number and remove "-"
         number = Request.Form("phoneTextBox")
         number = number.Remove(3, 1)

         ' generate words for first 3 digits
         outputTextBox.Text &= "Here are the words for the " & _
            "first three digits" & vbCrLf

         ComputeWords(number.Substring(0, 3), "")
         outputTextBox.Text &= vbCrLf

         ' generate words for last 4 digits
         outputTextBox.Text &= "Here are the words for the " & _
            "last 4 digits" & vbCrLf

         ComputeWords(number.Substring(3), "")

         outputTextBox.Visible = True
      End If

   End Sub ' Page_Load

   Private Sub ComputeWords(ByVal number As String, _
      ByVal temporaryWord As String)

      Dim current As Integer

      ' if number is empty, print word
      If number = "" Then
         outputTextBox.Text &= temporaryWord & vbCrLf
         Return
      End If

      ' retrieve first number and convert to Integer
      current = Convert.ToInt32(number.Substring(0, 1))

      ' delete first number
      number = number.Remove(0, 1)

      ' determine number, call ComputeWord recursively
      Select Case current

         ' 0 can be q or z
      Case 0
            ComputeWords(number, temporaryWord & "q")
            ComputeWords(number, temporaryWord & "z")

            ' 1 has no letter associated with it
         Case 1
            ComputeWords(number, temporaryWord & "")

            ' 2 can be a, b or c
         Case 2
            ComputeWords(number, temporaryWord & "a")
            ComputeWords(number, temporaryWord & "b")
            ComputeWords(number, temporaryWord & "c")

            ' 3 can be d, e or f
         Case 3
            ComputeWords(number, temporaryWord & "d")
            ComputeWords(number, temporaryWord & "e")
            ComputeWords(number, temporaryWord & "f")

            ' 4 can be g, h or i
         Case 4
            ComputeWords(number, temporaryWord & "g")
            ComputeWords(number, temporaryWord & "h")
            ComputeWords(number, temporaryWord & "i")

            ' 5 can be j, k or l
         Case 5
            ComputeWords(number, temporaryWord & "j")
            ComputeWords(number, temporaryWord & "k")
            ComputeWords(number, temporaryWord & "l")

            ' 6 can be m, n or o
         Case 6
            ComputeWords(number, temporaryWord & "m")
            ComputeWords(number, temporaryWord & "n")
            ComputeWords(number, temporaryWord & "o")

            ' 7 can be p, r or s
         Case 7
            ComputeWords(number, temporaryWord & "p")
            ComputeWords(number, temporaryWord & "r")
            ComputeWords(number, temporaryWord & "s")

            ' 8 can be t, u or v
         Case 8
            ComputeWords(number, temporaryWord & "t")
            ComputeWords(number, temporaryWord & "u")
            ComputeWords(number, temporaryWord & "v")

            ' 9 can be w, x or y
         Case 9
            ComputeWords(number, temporaryWord & "w")
            ComputeWords(number, temporaryWord & "x")
            ComputeWords(number, temporaryWord & "y")
      End Select

   End Sub ' ComputeWords
End Class ' Generator
