' Fig. 20.21: GuestbookPage.aspx
' The code-behind file for the guest book page.

Imports System.Web.UI.WebControls
Imports System.Data
Imports System.IO

' allows users to leave message
Public Class Guestbook
   Inherits System.Web.UI.Page

   Protected WithEvents promptLabel As Label
   Protected WithEvents nameLabel As Label
   Protected WithEvents emailLabel As Label
   Protected WithEvents messageLabel As Label
   Protected WithEvents dataGrid As dataGrid
   Protected WithEvents submitButton As Button
   Protected WithEvents messageTextBox As TextBox
   Protected WithEvents emailTextBox As TextBox
   Protected WithEvents nameTextBox As TextBox
   Protected WithEvents clearButton As Button
   Protected WithEvents dataView As System.Data.DataView

#Region " Web Form Designer Generated Code "

   ' This call is required by the Web Form Designer.
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      Me.dataView = New System.Data.DataView()
      CType(Me.dataView, System.ComponentModel.ISupportInitialize).BeginInit()
      CType(Me.dataView, System.ComponentModel.ISupportInitialize).EndInit()

   End Sub

   ' event handler for the Init event
   Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
      'CODEGEN: This method call is required by the Web Form Designer
      'Do not modify it using the code editor.
      InitializeComponent()
   End Sub

#End Region

   Private Sub Page_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

      'Put user code to initialize the page here
      dataView = New DataView(New DataTable())

   End Sub

   ' clear text boxes; user can enter new input
   Private Sub clearButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles clearButton.Click

      nameTextBox.Text = ""
      emailTextBox.Text = ""
      messageTextBox.Text = ""
   End Sub ' clearButton_Click

   Public Sub FillMessageTable()
      Dim table As New DataTable()
      Dim reader As StreamReader
      Dim separator As Char()
      Dim message As String
      Dim parts As String()

      table = dataView.Table

      table.Columns.Add("Date")
      table.Columns.Add("FirstName")
      table.Columns.Add("email")
      table.Columns.Add("Message")

      ' open guestbook file for reading
      reader = New StreamReader( _
         Request.PhysicalApplicationPath & "guestbook.txt")

      separator = New Char() {vbTab}

      ' read one line from file
      message = reader.ReadLine()

      While message <> ""

         ' split String into four parts
         parts = message.Split(separator)

         ' load data into table
         table.LoadDataRow(parts, True)

         ' read one line from file
         message = reader.ReadLine()
      End While

      dataGrid.DataBind() ' update grid

      reader.Close()
   End Sub ' FillMessageTable

   ' add the user's entry to the guestbook
   Private Sub submitButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles submitButton.Click

      Dim guestbook As StreamWriter

      ' open stream for appending to file
      guestbook = New StreamWriter( _
         Request.PhysicalApplicationPath & _
         "guestbook.txt", True)

      ' write new message to file
      guestbook.WriteLine( _
         DateTime.Now.Date.ToString().Substring(0, 10) & _
         vbTab & nameTextBox.Text & vbTab & emailTextBox.Text & _
         vbTab & messageTextBox.Text)

      ' clear textboxes and close stream
      nameTextBox.Text = ""
      emailTextBox.Text = ""
      messageTextBox.Text = ""
      guestbook.Close()

      FillMessageTable()
   End Sub ' submitButton_Click
End Class ' Guestbook
